/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 *********************************************************************/

#ifdef NETWORK

#ifndef CLASS_NETWORK_SERVER_HEADER
#define CLASS_NETWORK_SERVER_HEADER

#include <gnet.h>
#include <glibmm/iochannel.h>
#include "../os/os.h"

#define DEFAULT_PORT 2442

namespace Network {

  class IOChannel : public Glib::IOChannel {
    public:
      IOChannel(GIOChannel* gobject) :
	Glib::IOChannel(gobject, true) // ToDo: check second argument
      { }
  }; // class IOChannel : public Glib::IOChannel

  class Server : public OS {
    public:
      Server();
      ~Server();

      void start();
      void stop();


      void update();

    protected:
      void add_channel(GTcpSocket);

    private:
      // local internet address
      GInetAddr* local_addr;
      // port
      int port;

      // list of all iochannels
      vector<IOChannel> iochannels_clients;
  }; // class Server

} // namespace Network

#endif // #ifndef CLASS_NETWORK_SERVER_HEADE

#endif // #ifdef NETWORK
